/* -*-Mode:C; tab-width:4; indent-tabs-mode:t; c-file-style:"bsd";-*- */
//
// Project : progect
// Desc.   : Icon support code.
// $Id: icon.h,v 1.1 2000/09/28 13:26:04 seagull_kamome Exp $
//


#if !defined(H_ICONSUPPORT)
#define H_ICONSUPPORT

#if defined(__cplusplus)
extern "C" {
#endif

#define MAX_ICONS 70

#define getIconImage(id) (loadedIcon[id].image)
#define getIconDesc(id)  (loadedIcon[id].desc)
#define getNumIconsLoaded() (numIconLoaded)
#define getIconHeight(id) (8)
#define getIconWidth(id) (8)
#define getIconDataLength(id) (8)
#define getIconRowBytes(id) (1)
#define getIconColorDepth(id) (1)


// initialize icon handling module.
//  please call at first.
void initializeIcon(void);

// draw an icon specified by id, to (x, y).
void drawIcon(UInt8 id, int x, int y);

// event handler for icon select dialog.
Boolean FrmIconSelectHandleEvent(EventPtr e);


/////////////////////////////////////
// Internal use only.
//   don't direct access
typedef struct tag_IconType {
	char shortcut;
	char desc[32];
	UInt8 image[8];
} IconType;
extern UInt8 numIconLoaded;
extern IconType loadedIcon[MAX_ICONS];


#if defined(__cplusplus)
}
#endif


#endif


