/* -*-Mode:C; tab-width:4; indent-tabs-mode:t; c-file-style:"bsd";-*- */
// $Id: task.h,v 1.6 2000/10/22 18:35:27 burgbach Exp $
#ifndef __TASK_H__
#define __TASK_H__

#include "progect.h"

// first usable index in db
#define FIRST_INDEX 0

// first usable level
#define FIRST_LEVEL 1
#define ACTION 11
#define ACTION_OK 12
#define ACTION_NO 13
#define YEAR_OFFSET 1904 // for DateType


enum {
	Extra_NULL = 0,    // sentinel for block tail, must be subkey is zero.
	Extra_Description, // currently not used.
	Extra_Note,        // currently not used.

	Extra_Link_ToDo = 20,
	Extra_Link_LinkMaster,

	Extra_Icon = 50,
};


// DANGER!! 
//  This structer could not contain field large than 8bit.
//  becouse in task record. this structer stay on not even(word aligned) addr.
//  in this case motrola m68k serieas CPU gots bus-error.
typedef struct {
	UInt8 type;
	UInt8 subkey;	// subkey for same type chunks. 0xff is reserved.
					// if not use, must be set zero.
	UInt8 reserve1; //
	UInt8 size;		// not contain head size. please care word alignment.

	UInt8 body[0];  // data body. next chunk head exists at (body + size)
} ExtraChunkHeadType;
#define NextChunk(p) ((ExtraChunkHeadType*)((char*)(p)->body + (p)->size))
#define ChunkSize(p) ((UInt8)NextChunk(p) - (UInt8)(p))


// prototypes
// Tasks
pgErr    TaskSetAttr(DmOpenRef dbP, UInt16 index, TaskAttrType attr) 
	TASKSECT;
TaskAttrType TaskGetAttr(DmOpenRef dbP, UInt16 index) 
	TASKSECT;
pgErr    TaskSetFormat(DmOpenRef dbP, UInt16 index, TaskFormatType format)
	TASKSECT;
TaskFormatType TaskGetFormat(DmOpenRef dbP, UInt16 index)
    TASKSECT;
pgErr    TaskSetLevel(DmOpenRef dbP, UInt16 index, UInt8 level) 
	TASKSECT;
UInt8    TaskGetLevel(DmOpenRef dbP, UInt16 index) 
	TASKSECT;
pgErr    TaskSetPriority(DmOpenRef dbP, UInt16 index, UInt8 priority) 
	TASKSECT;
UInt8    TaskGetPriority(DmOpenRef dbP, UInt16 index) 
	TASKSECT;
pgErr    TaskSetHasChild(DmOpenRef dbP, UInt16 index, Boolean hasChild) 
	TASKSECT;
Boolean  TaskGetHasChild(DmOpenRef dbP, UInt16 index) 
	TASKSECT;
pgErr    TaskSetHasPrev(DmOpenRef dbP, UInt16 index, Boolean hasPrev) 
	TASKSECT;
Boolean  TaskGetHasPrev(DmOpenRef dbP, UInt16 index) 
	TASKSECT;
pgErr    TaskSetHasNext(DmOpenRef dbP, UInt16 index, Boolean next) 
	TASKSECT;
Boolean  TaskGetHasNext(DmOpenRef dbP, UInt16 index) 
	TASKSECT;
Boolean  TaskIsOpened(DmOpenRef dbP, UInt16 index) 
	TASKSECT;
Boolean  TaskIsVisible(DmOpenRef dbP, UInt16 index) 
	TASKSECT;
void TaskMakeVisible(DmOpenRef dbP, UInt16 index)
	TASKSECT;
Boolean  TaskToggleIsOpened(DmOpenRef dbP, UInt16 index) 
	TASKSECT;
pgErr    TaskSetOpened(DmOpenRef dbP, UInt16 index, Boolean value) 
	TASKSECT;
UInt16   TaskGetFatherIndex(DmOpenRef dbP, UInt16 index) 
	TASKSECT;
UInt16   TaskGetPrevIndex(DmOpenRef dbP, UInt16 index) 
	TASKSECT;
UInt16   TaskGetPrevIndexByLevel(DmOpenRef dbP, UInt16 index, UInt8 level) 
	TASKSECT;
UInt16   TaskGetNextIndex(DmOpenRef dbP, UInt16 index) 
	TASKSECT;
UInt16   TaskGetNextRelativeIndex(DmOpenRef dbP, UInt16 index) 
	TASKSECT;
pgErr    TaskSetActionState(DmOpenRef dbP, UInt16 index, Boolean action) 
	TASKSECT;
UInt8    TaskGetCompleted(DmOpenRef dbP, UInt16 index) 
	TASKSECT;
pgErr    TaskSetCompleted(DmOpenRef dbP, UInt16 index, UInt8 value) 
	TASKSECT;
Boolean  TaskGetIsDone(DmOpenRef dbP, UInt16 index) 
	TASKSECT;
Boolean  TaskGetActionState(DmOpenRef dbP, UInt16 index) 
	TASKSECT;
pgErr    TaskSetDueDate(DmOpenRef dbP, UInt16 index, DateType date) 
	TASKSECT;
DateType TaskGetDueDate(DmOpenRef dbP, UInt16 index) 
	TASKSECT;
pgErr    TaskSetNote(DmOpenRef dbP, UInt16 index, Char* note) 
	TASKSECT;
Char*    TaskGetNote(DmOpenRef dbP, UInt16 index) 
	TASKSECT;
Char* TaskGetDescription(DmOpenRef dbP, UInt16 index)
	TASKSECT;
Char* TaskGetDescriptionByTaskPtr(TaskExtendedRecordType* pTask)
	TASKSECT;
pgErr    TaskSetExtraBlock(DmOpenRef dbP, UInt16 index, MemPtr s, UInt32 size)
	TASKSECT;
UInt32   TaskGetExtraBlock(DmOpenRef dbP, UInt16 index, MemPtr dest)
	TASKSECT;
UInt32   TaskGetToDoUniqueID(DmOpenRef dbP, UInt16 index)
	TASKSECT;
pgErr    TaskCopyExtraBlock(DmOpenRef dbP, UInt16 source, UInt16 dest)
	TASKSECT;
pgErr    TaskInputDueDate(DmOpenRef dbP, UInt16 index) 
	TASKSECT;
pgErr    TaskSave(UInt16 index) 
	TASKSECT;
pgErr    TaskGetSaved(UInt16 index) 
	TASKSECT;
pgErr    TaskRemoveSaved(void) 
	TASKSECT;
pgErr    TaskRemove(DmOpenRef dbP, UInt16 index) 
	TASKSECT;
pgErr TaskRemoveChildren(DmOpenRef dbP, UInt16 index)
	TASKSECT;
pgErr    TaskRemoveDone(DmOpenRef dbP)
	TASKSECT;
pgErr    TaskRemoveDoneChildren(DmOpenRef dbP, UInt16 index)
	TASKSECT;
pgErr    TaskExpand(DmOpenRef dbP, UInt16 index) 
	TASKSECT;
pgErr    TaskCollapse(DmOpenRef dbP, UInt16 index) 
	TASKSECT;
pgErr    TaskCalcCompleted(DmOpenRef dbP, UInt16 index) 
	TASKSECT;
pgErr    TaskCalcCompletedAll(DmOpenRef dbP) 
	TASKSECT;
pgErr    TaskToRight(DmOpenRef dbP, UInt16 index) 
	TASKSECT;
pgErr    TaskToLeft(DmOpenRef dbP, UInt16 index) 
	TASKSECT;
pgErr    TaskUp(DmOpenRef dbP, UInt16 index) 
	TASKSECT;
pgErr    TaskDown(DmOpenRef dbP, UInt16 index) 
	TASKSECT;
pgErr    TaskPublishToDo(DmOpenRef dbP, UInt16 index)
	TASKSECT;
pgErr    TaskGetToDoStatus(DmOpenRef dbP, UInt16 index, UInt8 *value, 
	                       UInt8 *priority, DateType *dueDate)
	TASKSECT;
pgErr    TaskSetToDoStatus(DmOpenRef dbP, UInt16 index, UInt16 fields, 
						   UInt8 value, UInt16 priority, DateType dueDate)
	TASKSECT;
Err      TaskUpdateToDo(DmOpenRef dbP, UInt16 index)
	TASKSECT;
void     TaskSyncAll(void)
	TASKSECT;
pgErr    TaskRemoveHasToDo(DmOpenRef dbP, UInt16 index)
	TASKSECT;
pgErr    TaskRepairTree(DmOpenRef dbP, UInt16 start, UInt16 stop)
	TASKSECT;
pgErr    TaskToClipboard(DmOpenRef dbP, UInt16 index, Boolean withParent)
	TASKSECT;
pgErr    TaskFromClipboard(DmOpenRef dbP, UInt16 index, Boolean asChildren)
	TASKSECT;


pgErr    TaskGetExtraChunk(DmOpenRef dbP, UInt16 index,
                           UInt8 type, UInt8 subkey,
                           MemPtr dest, UInt16* size/*in bytes*/)
	TASKSECT;
pgErr    TaskGetExtraChunkByTaskPtr(TaskExtendedRecordType* pTask,
									UInt8 type, UInt8 subkey,
									MemPtr dest, UInt16* size/*in bytes*/)
	TASKSECT;
void    TaskRemoveExtraChunk(DmOpenRef dbP, UInt16 index,
                             UInt8 type, UInt8 subkey)
	TASKSECT;
pgErr    TaskSetExtraChunk(DmOpenRef dbP, UInt16 index,
                           UInt8 type, UInt8 subkey,
                           MemPtr src, UInt16 size)
	TASKSECT;

#endif
